package com.hzs.system.sys.service.impl;

import com.hzs.system.sys.result.UserOnlineResult;
import org.springframework.stereotype.Service;
import com.hzs.common.core.utils.StringUtils;
import com.hzs.system.sys.dto.LoginUser;
import com.hzs.system.sys.service.ISysUserOnlineService;

/**
 * 在线用户 服务层处理
 *
 * @author hzs
 */
@Service
public class SysUserOnlineServiceImpl implements ISysUserOnlineService {

    /**
     * 通过登录地址查询信息
     *
     * @param ipaddr 登录地址
     * @param user   用户信息
     * @return 在线用户信息
     */
    @Override
    public UserOnlineResult selectOnlineByIpaddr(String ipaddr, LoginUser user) {
        if (StringUtils.equals(ipaddr, user.getIpAddr())) {
            return loginUserToUserOnline(user);
        }
        return null;
    }

    /**
     * 通过用户名称查询信息
     *
     * @param userName 用户名称
     * @param user     用户信息
     * @return 在线用户信息
     */
    @Override
    public UserOnlineResult selectOnlineByUserName(String userName, LoginUser user) {
        if (StringUtils.equals(userName, user.getUsername())) {
            return loginUserToUserOnline(user);
        }
        return null;
    }

    /**
     * 通过登录地址/用户名称查询信息
     *
     * @param ipaddr   登录地址
     * @param userName 用户名称
     * @param user     用户信息
     * @return 在线用户信息
     */
    @Override
    public UserOnlineResult selectOnlineByInfo(String ipaddr, String userName, LoginUser user) {
        if (StringUtils.equals(ipaddr, user.getIpAddr()) && StringUtils.equals(userName, user.getUsername())) {
            return loginUserToUserOnline(user);
        }
        return null;
    }

    /**
     * 设置在线用户信息
     *
     * @param user 用户信息
     * @return 在线用户
     */
    @Override
    public UserOnlineResult loginUserToUserOnline(LoginUser user) {
        if (StringUtils.isNull(user)) {
            return null;
        }
        UserOnlineResult userOnlineResult = new UserOnlineResult();
        userOnlineResult.setTokenId(user.getToken());
        userOnlineResult.setUserName(user.getUsername());
        userOnlineResult.setIpaddr(user.getIpAddr());
        userOnlineResult.setLoginTime(user.getLoginTime());
        return userOnlineResult;
    }
}
